; ktipus.asm: K tpus hmr program MAX6675-hz. 8 mrs tlaga
; 2 s-onknt. Jumper hatsra 40-et levon. Jelzi a mrkr
; megszakadst. Soros kommunikci nincs.
; 1 darab hmrt kezel. Negyedek kijelzse 2 tizedessel.
; freki 4 MHz, tmr2 megszakts 1 kHz.

        include '16f886.inc'  ; a www.tech-tools.com honlaprl letlteni a tde52_qw272-1.exe                                          	; fjlt. Futtats utn a c:/pictools knyvtrban megtallhat
        fuses   _hs_osc&_pwrte_on&_bor_on&_wdt_off&_lvp_off
        fuses   _ieso_off&_fcmen_off

; kijelz rutinok bziscme
druts   equ     720h

; 4*20-as kijelz sorai (az els kett a 2*16-oshoz is j)
line1   equ     80h
line2   equ     0c0h
line3   equ     094h
line4   equ     0d4h
length  =       16
bsp     =       8

; egyb paramterek
speed   equ     12              		; kb. 19200 bps 4 MHz-rl
csen    equ     rc.0            		; neglt chip select

scale   equ     249             		; idoszt
t2ini   equ     1               		; t2 pre- s postscaler (4 s 1)
                                			; 1 ms alapidztshez

        org     20h

page    ds      1             		; szveglap
base    ds      1               		; szveg kezdcm
posi    ds      1               		; kijelzpozci
chars   ds      1               		; kirand karakterek szma
nyolc   ds      1               		; akku szmll
negyed  ds      1               		; a negyedek szma

count   ds      1               		; LCD idztsek bels szmllja
index   ds      1               		; LCD idztsek kls szmllja
lcd     ds      1               		; LCD kimenet adatregisztere
hossz   ds      1               		; kirand szveg hossza (munkareg.)
korr    ds      1               		; -40 vagy 0
t250    ds      1               		; 250 ms-os szmll

flags   ds      1               		; vegyes jelzbitek
flag    equ     flags.4         		; kijelz parancs/adat

toct    ds      1               		; timeout szmll
tocth   ds      1               		; timeout fels (negyedmsodpercek + 1)
stoct   ds      1               		; soros timeout (kb. 1s) szmll
timlo   ds      1               		; timer als bjt
timhi   ds      1               		; timer fels bjt
rtch    ds      1               		; timer ptbjt
pf      ds      1               		; process flags
kbe     equ     pf.0            		; beolvasskrs
szak    equ     pf.1            		; szakadsjelz
neg     equ     pf.6            		; negatv
car     equ     pf.7    			; aritm. s konv. rutin carry- s hibaflag
f1      ds      1
cgram   equ     f1.0    		; karaktergenertorba kell tlteni
storq   equ     f1.2    			; soros to krs
stoa    equ     f1.3    			; soros to lejrt
torq    equ     f1.4    			; ltalnos to krs
toa     equ     f1.5    			; ltalnos to lejrt
clkblk  ds      8

        org     70h     			; mentregiszterek
wtemp   ds      1
stemp   ds      1
ftemp   ds      1
ptemp   ds      1
rctemp  ds      1
ah      ds      1       			; aritmetikai s konverzis
al      ds      1       			; rutinok regiszterei
bh      ds      1
bl      ds      1
ch      ds      1
cl      ds      1
aux     ds      1
d2      equ     al
d1      equ     bh
d0      equ     bl
dh      ds      1
dl      ds      1

        org     0a0h    			; kijelzpufferek 
lb1     ds      20
lb2     ds      20
lb3     ds      20
lb4     ds      20
lcb1    equ     lb1
lcb2    equ     lb2


        org     0
        nop
        jmp     reset
        org     4
        mov     wtemp,w         		; ments (w, status, pclath)
        mov     w,<>status
        clr     status
        mov     stemp,w
        mov     w,pclath        		; a szveglapok miatt kell menteni
	mov     ptemp,w         	; ments vge
        clr     pclath          		; biztos, ami biztos
        mov     ftemp,fsr       		; ez mr a ments legvge
	clrb    tmr2if
        inc     timlo           		; 3 bjtos szmll, ami minden
        jnz     :sk             		; j tmr2 megszaktskor lp egyet.
        setb    go
        inc     timhi           		; elssorban idmrsre, de delta
        snz                     			; id gyannt regisztrlsra is.
        inc     rtch
:sk     sb      stoa            		; soros timeout szmll kezelse. max.255 ms.
	sb      storq
	jmp     :sk1
	djnz    stoct,:sk1
	setb    stoa
:sk1    decsz   t250
        jmp     rest1
        mov     t250,#250
        setb    kbe             		; 250 ms-onknt 1 krs
rest1   mov     fsr,ftemp       		; innen visszallts
	mov     pclath,ptemp
        mov     w,<>stemp
        mov     status,w
        swap    wtemp
        mov     w,<>wtemp
        reti

getq    jmp     pc+w            		; negyedtbla hagyomnyos kijelzshez
        retw    '0050257500507525'
vonal   jmp     pc+w            		; negyedtbla kvzigrafikus kijelzshez
        retw    32,6,5,7,32,6,7,5

reset   clr     intcon
        clrb    rp1
        clrb    rp0
        clr     ra
        mov     w,#0ffh ;?
        mov     rb,w
        mov     rc,w
        setb    rp0
        clr     pie1
        mov     w,#0
        mov     adcon1,w
        mov     w,#8
        mov     option,w
        mov     w,#1
        mov     trisa,w
        mov     w,#0f0h
        mov     trisb,w
        mov     w,#10h         
        mov     trisc,w
        setb    rp1
        clr     anselh
        mov     ansel,#1        		; ra0 analg bemenet lehetne
        clr     baudctl
        clrb    rp1
        mov     iocb,#0ffh
        clr     spbrgh
        clrb    sendb
        clrb    rp0
        mov     adcon0,#40h
        clrb    t1con.6
        setb    adon
        call    timini          		; kell a beolvasshoz
        clr     index
        call    dini
        call    mdelay
        call    mdelay
        mov     posi,#40h
        mov     page,#chgen<
        mov     base,#chgen>
        mov     chars,#64
        setb    cgram
        call    dispt
        call    mdelay
        clrb    cgram
        clr     sspcon
        setb    rp0
        setb    sspstat.6       
        clrb    sspstat.7
        clrb    rp0
        setb    sspen
        clr     pf
        clr     f1
mc      call    cls             		; kzvetlenl a kijelzn
        call    ldelay
        mov     nyolc,#8
        mov     t250,#250
        clr     ah
        clr     al
        mov     page,#emb<      		; kezdkp
        mov     base,#emb>
        mov     posi,#line1
        call    dt16
        call    mdelay
        setb    gie

; fhurok
malo    sb      kbe             		; tlltotta a 250. ms.
        jmp     malo
        clrb    kbe
        call    kin             		;  a berutin
        snb     szak            		; szakads bit, a berutin lltja
        jmp     err
        call    adbxax          		; akkumulci
        decsz   nyolc
        jmp     malo
        mov     nyolc,#8
        clr     negyed
        rr      ah
        rr      al
        rr      ah
        rr      al
        rr      ah
        rr      al
        rr      ah
        rr      al
        rl      negyed
        rr      ah
        rr      al
        rl      negyed
        and     ah,#03h
        clr     bh
        mov     korr,#-40
        snb     rb.7
        clr     korr
        mov     w,korr
        sz
        dec     bh
        mov     bl,w
        call    adbxax
        mov     bh,ah
        mov     bl,al
        call    sabsbx
        snb     bh.7
        setb    neg
        sb      bh.7
        clrb    neg
        clrb    bh.7
        mov     ah,bh
        mov     al,bl
        call    bibc16
        clr     ah
        clr     al              			; az akkumultor szabad

; s most mr csak a kirni val sort kell ellltani s kirni.
        mov     fsr,#lcb2
        mov     w,#20h
        snb     neg
        mov     w,#'-'
        mov     indf,w
        inc     fsr
        mov     w,<>ch
        and     w,#0fh
        or      w,#30h
        mov     indf,w
        inc     fsr
        mov     w,ch
        and     w,#0fh
        or      w,#30h
        mov     indf,w
        inc     fsr
        mov     w,<>cl
        and     w,#0fh
        or      w,#30h
        mov     indf,w
        inc     fsr
        mov     w,cl
        and     w,#0fh
        or      w,#30h
        mov     indf,w
        inc     fsr
        mov     w,#','
;        mov     w,negyed        		; ez a kt utasts rakn be a spec
;        call    vonal           		; karaktereket a vessz helyre
        mov     indf,w

; innen a tovbbi kirs a tmr formtumnl flsleges lenne
        inc     fsr
        clrb    c
        rl      negyed
        snb     neg
        rl      negyed
        mov     w,negyed
        call    getq
        mov     indf,w
        inc     fsr
        mov     w,++negyed
        call    getq
        mov     indf,w
; itt a tizedesek vge
        mov     posi,#line2
        mov     chars,#8        		; ez tartozik a kt tizedesre val kirshoz
;        mov     chars, #6       		; ez tartozna a grafikus negyedekhez
        mov     fsr,#lcb2
        call    dispv
        call    mdelay
        jmp     malo
err     mov     base,#hiba>     
        call    dt161           		; hibaszveg kirsa a 2. sorba
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        call    ldelay
        clrb    gie
        jmp     reset           		; jra fog indulni 3 s mlva!

; K be: chip select le, els be bjt bh, msodik be bjt bl, az egsz 3
; bittel le. (AX lehet a nyolcas akkumultor)
kin     clrb    csen
        call    bout
        nop
        mov     w,sspbuf
        mov     bh,w
        call    bout
        nop
        mov     w,sspbuf
        mov     bl,w
        setb    csen
        rr      bh
        rr      bl
        rr      bh
        rr      bl
        rr      bh
        rr      bl      
        snc
        setb    szak
        mov     w,#0fh
        and     bh,w
        ret

bout    mov     sspbuf,w        		; spi bjt ki (s be), vrakozssal
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        ret

timini  setb    rp0             		; TMR2 1 ms megszaktsi peridussal
        mov     w,#scale        		; 250-es oszt
        mov     pr2,w
        setb    tmr2ie
        clrb    rp0
        clrb    tmr2if
        mov     t2con,#t2ini    		; 4-es oszt
        setb    tmr2on
        setb    peie
        ret

        include 'arco16.inc'    		; 16 bites aritmetika + konverzi
        include 'lcd611.src'

        org     800h
lkup    jmp     w

; base=8
        org     810h
emb     retw    ' Eltolt program '              	; Fejlc
hiba    retw    ' Szakadt K...   '              	; hibazenet
chgen   retw   0eh,1fh,1fh,1fh,1fh,1fh,0eh,0   ; tele 0
        retw    0ah,11h,1fh,19h,1fh,11h,0ah,0   ; copyright
        retw    0eh,1fh,1fh,1fh,1fh,1fh,0eh,0
        retw    0,1,2,20,24,16,0,0              	; pipa
        retw    4,10,10,4,0,0,0,0               	; fok
        retw    0,0,0,0,0,0,1fh,0               	; egy vonal
        retw    0,0,0,0,1fh,0,1fh,0             	; kt vonal
        retw    0,0,1fh,0,1fh,0,1fh,0           	; hrom vonal
; emb s hiba egyenknt 16 karakter, chgen soronknt 8 karakter!!!

